
#
# Linux-GNU-arm-rzg2ul specific settings
#

# Set output dirs
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_SOURCE_DIR}/Binary/${CMAKE_SYSTEM_NAME}/${CMAKE_PLATFORM_NAME}/${CMAKE_CXX_COMPILER_ID}/${CMAKE_BUILD_TYPE}")

IF(STREAMRUNTIME_SDK_PROJECT)
  TARGET_LINK_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_EGAC}/Libraries/${CMAKE_SYSTEM_NAME}/${CMAKE_PLATFORM_NAME}/${CMAKE_CXX_COMPILER_ID}/${CMAKE_BUILD_TYPE}"
    PRIVATE "${PATH_GUILIANI}/Libraries/${CMAKE_SYSTEM_NAME}/${CMAKE_PLATFORM_NAME}/${CMAKE_CXX_COMPILER_ID}/${CMAKE_BUILD_TYPE}"
    )
ENDIF(STREAMRUNTIME_SDK_PROJECT)

# use shortcuts + cli on this platform
LIST(APPEND PLATFORM_DEFINES "STREAMRUNTIME_USE_CLI;STREAMRUNTIME_USE_SHORTCUTS")

# Set platform depenant include directories
TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
  PRIVATE "${PROJECT_SOURCE_DIR}/Common/Include/Platform/${CMAKE_SYSTEM_NAME}"
)

#eGML
IF(GUILIANI_ADD_EGML_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/eGML"
    PRIVATE "${PATH_GUILIANI}/Include/Platform/eGML/linux"
    PRIVATE "${PATH_GUILIANI}/Include/Platform/eGML/sdl"
  )
ENDIF(GUILIANI_ADD_EGML_PLATFORM)

#BLU
IF(GUILIANI_ADD_BLU_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/BLU"
    PRIVATE "${PATH_GUILIANI}/Include/Platform/BLU/sdl"
    PRIVATE "${PATH_BLU}/Include"
  )
ENDIF(GUILIANI_ADD_BLU_PLATFORM)

#GlyphLib
IF(GUILIANI_ADD_GLYPHLIB_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GLYPHLIB}/Include"
  )
ENDIF(GUILIANI_ADD_GLYPHLIB_PLATFORM)

# Collect platform source files
FILE(GLOB PLATFORM_RZG2UL_CPP
  "${PROJECT_SOURCE_DIR}/Common/Source/Platform/${CMAKE_SYSTEM_NAME}/StreamRuntime.cpp"
  "${PROJECT_SOURCE_DIR}/Common/Source/Platform/${CMAKE_PLATFORM_NAME}/StreamRuntimeStartup.cpp"
)

# Set platform source files
SET(PLATFORM_FILES 
    ${PLATFORM_RZG2UL_CPP}
)
